# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool sh %{SOURCE10}
# end stuff to be ...

# if kversion isn't defined on rpm build line, build against current kernel
%{!?kversion: %define kversion %(uname -r)}

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name xfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define paevar PAE
%endif

%ifarch ppc64 ppc64iseries
%define kdumpvar kdump
%endif

%ifarch sparc64 ppc
%define smpvar smp
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?paevar} %{?kdumpvar}}

# hint: this can he overridden with "--define kvariants foo bar" on the rpmbuild command line, e.g.
# --define 'kvariants "" smp' 

Name:           %{kmod_name}-kmod
Version:        0.4
Release:        1.%(echo %{kverrel} | tr - _)
Summary:        %{kmod_name} kernel modules
Packager:	Eric Sandeen <sandeen-centos@sandeen.net>

Group:          System Environment/Kernel
License:        GPL
URL:            http://oss.sgi.com/projects/xfs
Source0		: %{kmod_name}.tar.bz2

Source1		: config.xfs

# Allow the code to build as an out-of-tree module
Patch0		: xfs-ootbuild.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i586 i686 x86_64 ppc ia64 sparc64 ppc64

%description
The XFS(tm) Filesystem from Silicon Graphics, Inc.
XFS is a highly scalable, high-performance journaling filesystem that provides 
rapid recovery from system crashes.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
#pushd %{kmod_name}-%{version}
pushd %{kmod_name}
cp %{SOURCE1} .
# build glue
%patch0 -p1

popd
for kvariant in %{kvariants} ; do
#    cp -a %{kmod_name}-%{version} _kmod_build_${kvariant}
    cp -a %{kmod_name} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant
    make TOPDIR=${ksrc} modules %{?_smp_mflags}
    # make -C "${ksrc}" SUBDIRS=${PWD} modules %{?_smp_mflags}
    cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant
    make TOPDIR=${ksrc} INSTALL_MOD_PATH=$RPM_BUILD_ROOT INSTALL_MOD_DIR=extra/%{kmod_name} modules_install %{?_smp_mflags}
    cd ..
    #make install \
    #     DESTDIR=$RPM_BUILD_ROOT
    #     INST_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Thu Apr 19 2007 Johnny Hughes <johnny@centos.org> 0.3-2
- Modified kmodtool (Source10) to remove the requirement for xfs-kmod-common
 
* Tue Apr 17 2007 Johnny Hughes <johnny@centos.org>
- Initial use in CentOS-5
- Added paevar and modified paevar, smpvar, xenvar, xdumpvar to follow
  EL5 and not FC6 naming conventions.

